//=============================================================================
// RLCoopSNotify.
//=============================================================================
class RLCoopSNotify expands SpawnNotify;

var int oldhealth;

struct starthealths
{
	var ScriptedPawn Pawn;
	var int Health;
	var float GroundSpeed;
	var float AirSpeed;
	var float WaterSpeed;
};

var array<starthealths> StartPawns;

Simulated Function PostBeginPlay()
{
	local actor A;

ActorClass=Class'Actor';

 Super.PostBeginPlay();
 
 foreach allactors(Class'Actor',A)
 {
  if(ScriptedPawn(A)!=None)
  {
		A.bAlwaysRelevant = true;
		Array_Insert(StartPawns, Array_Size(StartPawns));
		StartPawns[Array_Size(StartPawns)-1].Pawn = ScriptedPawn(A);
		StartPawns[Array_Size(StartPawns)-1].Health = ScriptedPawn(A).Health;
		StartPawns[Array_Size(StartPawns)-1].GroundSpeed = ScriptedPawn(A).GroundSpeed;
		StartPawns[Array_Size(StartPawns)-1].AirSpeed = ScriptedPawn(A).AirSpeed;
		StartPawns[Array_Size(StartPawns)-1].WaterSpeed = ScriptedPawn(A).WaterSpeed;
  }


  if(ScriptedPawn(A)!=None && ScriptedPawn(A).Intelligence == BRAINS_HUMAN)
  {
		ScriptedPawn(A).bLeadTarget = True;
  }

  if(ScriptedPawn(A)!=None && ScriptedPawn(A).Intelligence != BRAINS_HUMAN)
  {
		ScriptedPawn(A).bLeadTarget = False;
  }


  if(Weapon(A)!=None) Weapon(A).bOwnsCrosshair = true;
  if(Decoration(A)!=None && Carcass(A)==None) A.Mass = 10;
  if(Decoration(A)!=None) A.Buoyancy = 20;
//  if(Carcass(A)!=None) A.bBlockPlayers = True;
//  if(Carcass(A)!=None) A.bBlockActors = True;


  	if(Inventory(A)!=None)
	{
		A.bProjTarget = True;
		Inventory(A).bAmbientGlow=False;
		Inventory(A).AmbientGlow=0;
		Inventory(A).bRotatingPickup=False;
		A.SetCollision(False);
	}
 }
}

simulated event Actor SpawnNotification(Actor A)
{
	local Pawn P;
	
	if(ScriptedPawn(A)!=None)
	{
		Array_Insert(StartPawns, Array_Size(StartPawns));
		StartPawns[Array_Size(StartPawns)-1].Pawn = ScriptedPawn(A);
		StartPawns[Array_Size(StartPawns)-1].Health = ScriptedPawn(A).Health;
		StartPawns[Array_Size(StartPawns)-1].GroundSpeed = ScriptedPawn(A).GroundSpeed;
		StartPawns[Array_Size(StartPawns)-1].AirSpeed = ScriptedPawn(A).AirSpeed;
		StartPawns[Array_Size(StartPawns)-1].WaterSpeed = ScriptedPawn(A).WaterSpeed;
	}


  if(ScriptedPawn(A)!=None && ScriptedPawn(A).Intelligence == BRAINS_HUMAN)
  {
		ScriptedPawn(A).bLeadTarget = True;
  }

  if(ScriptedPawn(A)!=None && ScriptedPawn(A).Intelligence != BRAINS_HUMAN)
  {
		ScriptedPawn(A).bLeadTarget = False;
  }


	if(ScriptedPawn(A)!=None || DripGenerator(A)!=None || Effects(A)!=None /*|| Inventory(A)!=None*/ || Projectile(A)!=None) A.bAlwaysRelevant = true;
	if(Weapon(A)!=None) Weapon(a).bOwnsCrosshair=true;
	if(Inventory(A)!=None)
	{
		A.bProjTarget = True;
		Inventory(A).bAmbientGlow=False;
		Inventory(A).AmbientGlow=0;
		Inventory(A).bRotatingPickup=False;
		A.SetCollision(False);
	}
	if(Decoration(A)!=None && Carcass(A)==None) A.Mass = 10;
	if(Decoration(A)!=None) A.Buoyancy = 20;
//    if(Carcass(A)!=None) A.bBlockPlayers = True;
//    if(Carcass(A)!=None) A.bBlockActors = True;

	return A;
}


simulated function SetPawnSpeed(ScriptedPawn P)
{
	/*local int OldHealth;
	local float OldGSpeed, OldASpeed, OldWSpeed;
	
	if(FindStartVars(P, OldHealth, OldGSpeed, OldASpeed, OldWSpeed))
	{
		P.GroundSpeed = OldGSpeed * (0.75+0.25*(float(P.Health)/float(OldHealth)));
		P.AirSpeed = OldASpeed * (0.75+0.25*(float(P.Health)/float(OldHealth)));
		P.WaterSpeed = OldWSpeed * (0.75+0.25*(float(P.Health)/float(OldHealth)));
//		if(Brute(P)!=None && Brute(P).bBerserk) P.GroundSpeed *= 2.5;
	}*/
}

simulated function bool FindStartVars(ScriptedPawn P, out int OldHealth, out float OldGSpeed, out float OldASpeed, out float OldWSpeed)
{
	local int I;
	
	For(I=0; I<Array_Size(StartPawns); I++)
	if(StartPawns[I].Pawn==None) Array_Remove(StartPawns,I);
	else if(StartPawns[I].Pawn==P)
	{
		OldHealth = StartPawns[I].Health;
		OldGSpeed = StartPawns[I].GroundSpeed;
		OldASpeed = StartPawns[I].AirSpeed;
		OldWSpeed = StartPawns[I].WaterSpeed;
		Return True;
	}
	return False;
}

Simulated Function Tick(float DT)
{
	local scriptedpawn p;
	foreach allactors(class'ScriptedPawn', P)
		SetPawnSpeed(P);
}





/*


Simulated Function PostBeginPlay()

{

local weapon w;

//local actor az;

//local unrealblood ub;

local pawn p;

local decoration d;

ActorClass=Class'Actor';

Super.PostBeginPlay();

foreach allactors(Class'Weapon',W) W.bOwnsCrosshair = true;

foreach allactors(Class'Pawn',P) P.bAlwaysRelevant = true;

foreach allactors(Class'Decoration',D) D.Mass = 10;

}


simulated event Actor SpawnNotification(Actor A)

{

weapon(a).bOwnsCrosshair=true;

return a;

}

*/

defaultproperties
{
				DrawType=DT_Mesh
				DrawScale=0.000000
}
